/*
 * main.c
 *
 * Created: 2014-02-15 14:13:47
 *  Author: Piotr
 *
 * Description: Program demonstrujcy eliminacj drga stykw z wykorzystaniem timera dla ukadw joysticka itp. 
 *              (tylko jeden aktywny w tym samym czasie przycisk)
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>

#include "debounce.h"
#include "HD44780.h"


//definiuj funkcj odczytu stanu przyciskw
uint8_t menu_read(void){
	if(!(PIND&(1<<PD5)))return 1;
	if(!(PIND&(1<<PD6)))return 2;
	if(!(PIND&(1<<PD7)))return 3;
	return 0;
}

//inicjalizacja hardware do przyciskw
void menu_hw_init(void){
	DDRD &= ~((1<<PD7)|(1<<PD6)|(1<<PD5));//piny jako wejcia
	PORTD |= ((1<<PD7)|(1<<PD6)|(1<<PD5));//podciganie
	
	TCCR0A |= (1<<WGM01);//tryb CTC dla timera 0
	OCR0A = F_CPU/1024/100;//wyliczamy warto OCR dla osignicia przerwania o okresie okoo 10ms
	TCCR0B |= (1<<CS00)|(1<<CS02);//preskaler 1024
	TIMSK0 |= (1<<OCIE0A);//zezwolenie na przerwanie od OCR0A
}

//definiuj odpowiednie funkcje dla przytrzymania i klikania przyciskw
void click_1(void){
	static uint8_t count=0;
	char buffer[17];
	count++;
	LCD_GoTo(0,1);
	sprintf(buffer,"Click 1:%03d",count);
	LCD_WriteText(buffer);
}

void hold_1(void){
	static uint8_t count=0;
	char buffer[17];
	count++;
	LCD_GoTo(0,1);
	sprintf(buffer,"Hold 1 :%03d",count);
	LCD_WriteText(buffer);
}


void click_2(void){
	static uint8_t count=0;
	char buffer[17];
	count++;
	LCD_GoTo(0,1);
	sprintf(buffer,"Click 2:%03d",count);
	LCD_WriteText(buffer);
}

void hold_2(void){
	static uint8_t count=0;
	char buffer[17];
	count++;
	LCD_GoTo(0,1);
	sprintf(buffer,"Hold 2 :%03d",count);
	LCD_WriteText(buffer);
}


void click_3(void){
	static uint8_t count=0;
	char buffer[17];
	count++;
	LCD_GoTo(0,1);
	sprintf(buffer,"Click 3:%03d",count);
	LCD_WriteText(buffer);
}

void hold_3(void){
	static uint8_t count=0;
	char buffer[17];
	count++;
	LCD_GoTo(0,1);
	sprintf(buffer,"Hold 3 :%03d",count);
	LCD_WriteText(buffer);
}

int main(void)
{
	menu_init();//inicjalizacja systemw menu
	menu_hw_init();
	
	LCD_Initalize();
	sei();//wczenie globalne przerwa
	LCD_GoTo(0,0);
	LCD_WriteText("  Debounce demo ");
	
	//przypisujemy funkcje do odpowiednich dziaa
	click[1]=click_1;
	hold[1]=hold_1;
	click[2]=click_2;
	hold[2]=hold_2;
	click[3]=click_3;
	hold[3]=hold_3;
	
	//w ptli gwnej nie robimy zupenie nic!!!
    while(1){
		//pustki - procesor wikszo czasu moe robi co innego!!!
	}
}

ISR(TIMER0_COMPA_vect){
	//w przerwaniu moemy wykonywa te wiele innych czynnoci, a jeli przerwanie wystpuje czciej ni co okoo 10ms
	//moemy wywoywa t funkcj co ktre przerwanie.
	menu_check();
}